<?php
class ControllerFeedXmlFeed extends Controller {
	public function index() {
		if ($this->config->get('xmlfeed_status')) {
			$output  = '<?xml version="1.0" encoding="UTF-8"?>';
			$output .= '<Products xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:image="http://www.google.com/schemas/sitemap-image/1.1">';
			$this->load->model('catalog/product');
			$this->load->model('catalog/category');
			$this->load->model('tool/image');
			$products = $this->model_catalog_product->getProducts();
			foreach ($products as $product) {
				if ($product['image']) {
					$output .= '<Product>';
					$output .= '<id>' . $product['product_id'] . '</id>';
					$output .= '<ProductName>' . $product['name'] . '</ProductName>';					
					if ($product['model']) {
					$output .= '<model>' . $product['model'] . '</model>';
					}
					if ($product['sku']) {
					$output .= '<sku>' . $product['sku'] . '</sku>' ;
					}
					if ($product['upc']) {
					$output .= '<upc>' . $product['upc'] . '</upc>';
					}
					if ($product['ean']) {
	                $output .= '<ean>' . $product['ean'] . '</ean>';
					}
					if ($product['jan']) {
					$output .= '<jan>' . $product['jan'] . '</jan>';
					}
					if ($product['isbn']) {
					$output .= '<isbn>' . $product['isbn'] . '</isbn>' ;
					}
					if ($product['mpn']) {
					$output .= '<mpn>' . $product['mpn'] . '</mpn>';
					}
					if ($product['location']) {
	                $output .= '<location>' . $product['location'] . '</location>';
					}
					if ($product['status']) {
	                $output .= '<status>' . $product['status'] . '</status>';
					}
					$output .= '<brand>' . $product['manufacturer'] . '</brand>';
					$output .= '<ProductQTY>' . $product['quantity']. '</ProductQTY>';
					$output .= '<price>' . $product['price'] . '</price>';
					$output .= '<points>' . $product['points']. '</points>';
					$output .= '<price>' . $product['price'] . '</price>';
				    $output .= '<date_available>' . $product['date_available'] . '</date_available>';
					$output .= '<weight>' . $product['weight']. '</weight>';
					$output .= '<length>' . $product['length'] . '</length>';
					$output .= '<width>' . $product['width'] . '</width>';
					$output .= '<height>' . $product['height']. '</height>';
					$output .= '<minimum>' . $product['minimum'] . '</minimum>';
					$output .= '<sort_order>' . $product['sort_order'] . '</sort_order>';
					$output .= '<date_added>' . $product['date_added']. '</date_added>';
					$output .= '<date_modified>' . $product['date_modified'] . '</date_modified>';
					$categories = $this->model_catalog_product->getCategories($product['product_id']);
					foreach ($categories as $category) {
						$path = $this->getPath($category['category_id']);
						if ($path) {
							$string = '';
							foreach (explode('_', $path) as $path_id) {
								$category_info = $this->model_catalog_category->getCategory($path_id);
								if ($category_info) {
									if (!$string) {
										$string = $category_info['name'];
									} else {
										$string .= ' &gt; ' . $category_info['name'];
									}
								}
							}
							
						}
					}
					$output .= '<FullCategoryPath>' . $string . '</FullCategoryPath>';
					$output .= '<description><![CDATA['. $product['description'] . ']]></description>';
					$output .= '<link>' . $this->url->link('product/product', 'product_id=' . $product['product_id']) . '</link>';
					$output .= '<image_link>' . $this->model_tool_image->resize($product['image'], $this->config->get('config_image_popup_width'), $this->config->get('config_image_popup_height')) . '</image_link>';					
					$output .= '</Product>';
				}
			}
			$output .= '</Products>';
			$this->response->addHeader('Content-Type: application/xml');
			$this->response->setOutput($output);
		}
	}
	protected function getPath($parent_id, $current_path = '') {
		$category_info = $this->model_catalog_category->getCategory($parent_id);
		if ($category_info) {
			if (!$current_path) {
				$new_path = $category_info['category_id'];
			} else {
				$new_path = $category_info['category_id'] . '_' . $current_path;
			}	
			$path = $this->getPath($category_info['parent_id'], $new_path);
			if ($path) {
				return $path;
			} else {
				return $new_path;
			}
		}
	}
}
